/* librnpl.h */
/* Copyright (c) 1995 by Robert Marsa */

#ifndef _LIBRNPL_H
#define _LIBRNPL_H

#include <bbh_types.h>
#include <sys/types.h>
#include <bbhutil.h>

#define STR_P_SIZE 64

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  BBH_I cs; /* coordinate system */
  BBH_I rank;
  BBH_I shape[MAXRANK];
  BBH_I bounds[2*MAXRANK];
  BBH_D *coords[MAXRANK];
} lattice_type;

typedef struct {
  BBH_I type;
  BBH_D *val;
  lattice_type *lat;
} gfunc_type;

typedef struct {
  BBH_I id;
  BBH_I cs;
  BBH_I rank;
  BBH_I shape[MAXRANK];
  BBH_I bounds[2*MAXRANK];
  BBH_I cptr[MAXRANK];
} latcb;

typedef struct {
  BBH_I n_coord;
  BBH_D *coord;
} coords;

BBH_I rvsxynt(BBH_C *n, BBH_D t, BBH_D *r, 
              BBH_D *u, BBH_I N);

BBH_V rdvcpy(BBH_D *r,BBH_D *s, BBH_I len);

/* allocate a vector of size BBH_Ds, named name.  Print
   error message and exit if not enough memory */
BBH_D * vec_alloc_n(BBH_I size, BBH_C *name);

/* returns a vector of size BBH_Is named name;  
   prints error message and exits if not enough memory */
BBH_I * ivec_alloc_n(BBH_I size, BBH_C *name);

BBH_V gf_output(gfunc_type *gfuncs, BBH_C **fnames, BBH_C ***cnames,
               BBH_D t, BBH_I ser, BBH_I fout, 
               BBH_I nout_f, BBH_I *lout_f,
               BBH_I *gf_st, BBH_I *gf_ln);

BBH_I encode(BBH_I *lar, BBH_I *ar, BBH_I nar);

BBH_V gff_output(BBH_I *ptrs, BBH_D *q, BBH_C **fnames, BBH_I ngfls, 
                BBH_C **cnames, BBH_I ncnames, BBH_D t, BBH_I ser, BBH_I fout,
                BBH_I nout_f, BBH_I *lout_f, BBH_I *gf_st, BBH_I *gf_ln);


#ifdef __cplusplus
}
#endif

#endif
